package com.fjhx.xmhjc.controller.browsing;

import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.browsing.vo.BrowsingHistoryVo;
import com.fjhx.xmhjc.entity.browsing.dto.BrowsingHistorySelectDto;
import com.fjhx.xmhjc.entity.browsing.dto.BrowsingHistoryDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.fjhx.xmhjc.service.browsing.BrowsingHistoryService;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * <p>
 * 浏览记录 前端控制器
 * </p>
 *
 * @author 
 * @since 2024-05-21
 */
@RestController
@RequestMapping("/browsingHistory")
public class BrowsingHistoryController {

    @Autowired
    private BrowsingHistoryService browsingHistoryService;

    /**
     * 浏览记录列表
     */
    @PostMapping("/list")
    public List<BrowsingHistoryVo> list(@RequestBody BrowsingHistorySelectDto dto) {
        return browsingHistoryService.getList(dto);
    }

    /**
     * 浏览记录分页
     */
    @PostMapping("/page")
    public Page<BrowsingHistoryVo> page(@RequestBody BrowsingHistorySelectDto dto) {
        return browsingHistoryService.getPage(dto);
    }

    /**
     * 浏览记录明细
     */
    @PostMapping("/detail")
    public BrowsingHistoryVo detail(@RequestBody BaseSelectDto dto) {
        return browsingHistoryService.detail(dto.getId());
    }

    /**
     * 浏览记录新增
     */
    @PostMapping("/add")
    public void add(@RequestBody BrowsingHistoryDto browsingHistoryDto) {
        browsingHistoryService.add(browsingHistoryDto);
    }

    /**
     * 浏览记录编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody BrowsingHistoryDto browsingHistoryDto) {
        browsingHistoryService.edit(browsingHistoryDto);
    }

    /**
     * 浏览记录删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        browsingHistoryService.delete(dto.getId());
    }

}
