package com.fjhx.xmhjc.controller.product;

import cn.hutool.core.collection.CollectionUtil;
import com.fjhx.xmhjc.entity.product.dto.ProductInfoDto;
import com.fjhx.xmhjc.entity.product.dto.ProductInfoSelectDto;
import com.fjhx.xmhjc.entity.product.po.ProductInfo;
import com.fjhx.xmhjc.entity.product.vo.ProductInfoVo;
import com.fjhx.xmhjc.service.product.ProductInfoService;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.product.vo.ProductCategoryVo;
import com.fjhx.xmhjc.entity.product.dto.ProductCategorySelectDto;
import com.fjhx.xmhjc.entity.product.dto.ProductCategoryDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.fjhx.xmhjc.service.product.ProductCategoryService;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 * 产品类目表 前端控制器
 * </p>
 *
 * @author hj
 * @since 2023-11-12
 */
@RestController
@RequestMapping("/productCategory")
public class ProductCategoryController {

    @Autowired
    private ProductCategoryService productCategoryService;
    @Resource
    private ProductInfoService productInfoService;

    /**
     * 产品类目表列表
     */
    @PostMapping("/list")
    public List<ProductCategoryVo> list(@RequestBody ProductCategorySelectDto dto) {
        return productCategoryService.getList(dto);
    }

    /**
     * 产品类目表分页
     */
    @PostMapping("/page")
    public Page<ProductCategoryVo> page(@RequestBody ProductCategorySelectDto dto) {
        return productCategoryService.getPage(dto);
    }

    /**
     * 产品类目表明细
     */
    @PostMapping("/detail")
    public ProductCategoryVo detail(@RequestBody BaseSelectDto dto) {
        return productCategoryService.detail(dto.getId());
    }

    /**
     * 产品类目表新增
     */
    @PostMapping("/add")
    public void add(@RequestBody ProductCategoryDto productCategoryDto) {
        productCategoryService.add(productCategoryDto);
    }

    /**
     * 产品类目表编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody ProductCategoryDto productCategoryDto) {
        productCategoryService.edit(productCategoryDto);
    }

    /**
     * 产品类目表删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        ProductInfoSelectDto productInfoSelectDto = new ProductInfoSelectDto();
        productInfoSelectDto.setCategoryId(dto.getId());
        List<ProductInfoVo> productInfoVos = productInfoService.getList(productInfoSelectDto);
        if(CollectionUtil.isNotEmpty(productInfoVos)){
            throw new RuntimeException("该类目下有产品，不能删除");
        }
        productCategoryService.delete(dto.getId());
    }

    /**
     * 产品信息修改状态
     */
    @PostMapping("/changeStatus")
    public void changeStatus(@RequestBody ProductCategoryDto productCategoryDto) {
        productCategoryService.changeStatus(productCategoryDto);
    }

}
