package com.fjhx.xmhjc.service.browsing;

import com.fjhx.xmhjc.entity.browsing.dto.AddBrowsingDto;
import com.fjhx.xmhjc.entity.browsing.po.BrowsingHistory;
import com.ruoyi.common.core.service.BaseService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.browsing.vo.BrowsingHistoryVo;
import com.fjhx.xmhjc.entity.browsing.dto.BrowsingHistorySelectDto;
import com.fjhx.xmhjc.entity.browsing.dto.BrowsingHistoryDto;

import java.util.List;

/**
 * <p>
 * 浏览记录 服务类
 * </p>
 *
 * @author 
 * @since 2024-05-21
 */
public interface BrowsingHistoryService extends BaseService<BrowsingHistory> {

    /**
     * 浏览记录列表
     */
    List<BrowsingHistoryVo> getList(BrowsingHistorySelectDto dto);

    /**
     * 浏览记录分页
     */
    Page<BrowsingHistoryVo> getPage(BrowsingHistorySelectDto dto);

    /**
     * 浏览记录明细
     */
    BrowsingHistoryVo detail(Long id);

    /**
     * 浏览记录新增
     */
    void add(BrowsingHistoryDto browsingHistoryDto);

    /**
     * 浏览记录编辑
     */
    void edit(BrowsingHistoryDto browsingHistoryDto);

    /**
     * 浏览记录删除
     */
    void delete(Long id);

    void addBrowsingHistory(AddBrowsingDto addBrowsingDto);
}
