package com.fjhx.xmhjc.service.browsing.impl;

import cn.hutool.core.date.DateUtil;
import com.fjhx.xmhjc.entity.browsing.dto.AddBrowsingDto;
import com.fjhx.xmhjc.entity.browsing.po.BrowsingHistory;
import com.fjhx.xmhjc.mapper.browsing.BrowsingHistoryMapper;
import com.fjhx.xmhjc.service.browsing.BrowsingHistoryService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.xmhjc.utils.NetUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.ServletUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.browsing.vo.BrowsingHistoryVo;
import com.fjhx.xmhjc.entity.browsing.dto.BrowsingHistorySelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.xmhjc.entity.browsing.dto.BrowsingHistoryDto;
import cn.hutool.core.bean.BeanUtil;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 浏览记录 服务实现类
 * </p>
 *
 * @author 
 * @since 2024-05-21
 */
@Service
public class BrowsingHistoryServiceImpl extends ServiceImpl<BrowsingHistoryMapper, BrowsingHistory> implements BrowsingHistoryService {

    @Override
    public List<BrowsingHistoryVo> getList(BrowsingHistorySelectDto dto) {
        IWrapper<BrowsingHistory> wrapper = getWrapper();
        wrapper.orderByDesc("bh", BrowsingHistory::getId);
        List<BrowsingHistoryVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<BrowsingHistoryVo> getPage(BrowsingHistorySelectDto dto) {
        IWrapper<BrowsingHistory> wrapper = getWrapper();
        wrapper.orderByDesc("bh", BrowsingHistory::getId);
        Page<BrowsingHistoryVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public BrowsingHistoryVo detail(Long id) {
        BrowsingHistory BrowsingHistory = this.getById(id);
        BrowsingHistoryVo result = BeanUtil.toBean(BrowsingHistory, BrowsingHistoryVo.class);
        return result;
    }

    @Override
    public void add(BrowsingHistoryDto browsingHistoryDto) {
        this.save(browsingHistoryDto);
    }

    @Override
    public void edit(BrowsingHistoryDto browsingHistoryDto) {
        this.updateById(browsingHistoryDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

    @Override
    public void addBrowsingHistory(AddBrowsingDto addBrowsingDto) {
        HttpServletRequest request = ServletUtils.getRequest();
        String ip = NetUtils.getIpAddress(request);
        BrowsingHistoryDto browsingHistoryDto = new BrowsingHistoryDto();
        BeanUtil.copyProperties(addBrowsingDto, browsingHistoryDto);
        browsingHistoryDto.setIp(ip);
        Date createTime = addBrowsingDto.getCreateTime();
        browsingHistoryDto.setYear(DateUtil.year(createTime));
        browsingHistoryDto.setMonth(DateUtil.month(createTime) + 1);
        browsingHistoryDto.setDay(DateUtil.dayOfMonth(createTime));
        browsingHistoryDto.setHour(DateUtil.hour(createTime, true));
        browsingHistoryDto.setWeek(DateUtil.weekOfYear(createTime));
        add(browsingHistoryDto);
    }
}
